-- @(#)12.sql	2.1.8.1
-- TPC-H/TPC-R Shipping Modes and Order Priority Query (Q12)
-- Functional Query Definition
-- Approved February 1998
set term ^;
create procedure query12
	returns (l_shipmode char(10), highprio integer,
		lowprio integer)
as
	declare variable o_orderpriority char(15);
begin
	for
		select
			l_shipmode,
			o_orderpriority
		from
			orders,
			lineitem
		where
			o_orderkey = l_orderkey
			and l_shipmode in ('MAIL', 'SHIP')
			and l_commitdate < l_receiptdate
			and l_shipdate < l_commitdate
			and l_receiptdate >= date '1994-01-01'
			and l_receiptdate < date '1995-01-01'
		into
			:l_shipmode,
			:o_orderpriority
	do
	begin
		if 
			((o_orderpriority = '1-URGENT') or 
			(o_orderpriority = '2-HIGH')) 
		then
		begin
			highprio = 1;
			lowprio = 0;
		end
		else
		begin
			highprio = 0;
			lowprio = 1;
		end
		suspend;
	end
end^
set term ;^

:staton
select
	l_shipmode,
	sum(highprio) as high_line_count,
	sum(lowprio) as low_line_count
from
	query12
group by 	
	l_shipmode
order by
	l_shipmode;
:statoff

commit;
drop procedure query12;

