-- @(#)14.sql	2.1.8.1
-- TPC-H/TPC-R Promotion Effect Query (Q14)
-- Functional Query Definition
-- Approved February 1998
set term ^;
create procedure query14
	returns (promorev numeric(18,2), revenue numeric(18,2))
as
	declare variable p_type varchar(25);
begin
	for
		select
			p_type,
			l_extendedprice * (1 - l_discount)
		from
			lineitem,
			part
		where
			l_partkey = p_partkey
			and l_shipdate >= date '1995-09-01'
			and l_shipdate < date '1995-10-01'
		into
			:p_type,
			:revenue
	do
	begin
		if (p_type like 'PROMO%') then
			promorev = revenue;
		else
			promorev = 0;
		suspend;
	end
end^
set term ;^

:staton
select
	100.00 * sum(promorev) / sum(revenue) as promo_revenue
from
	query14;
:statoff

commit;
drop procedure query14;

