-- @(#)15.sql	2.1.8.1
-- TPC-H/TPC-R Top Supplier Query (Q15)
-- Functional Query Definition
-- Approved February 1998
create view revenue0 (supplier_no, total_revenue) as
	select
		l_suppkey,
		cast(sum(l_extendedprice * (1 - l_discount)) as numeric(18,2))
	from
		lineitem
	where
		l_shipdate >= date '1996-01-01'
		and l_shipdate < date '1996-04-01'
	group by
		l_suppkey;

set term ^;
create procedure query15 
	returns (s_suppkey integer, s_name char(25),
		s_address varchar(40), s_phone char(15),
		total_revenue numeric(18,2))
as
	declare variable total_rev numeric(18,2);
begin
	select max(total_revenue) from revenue0 into :total_rev;
	
	for
		select
			s_suppkey,
			s_name,
			s_address,
			s_phone,
			total_revenue
		from
			supplier,
			revenue0
		where
			s_suppkey = supplier_no
			and total_revenue = :total_rev
		order by
			s_suppkey
		into
			:s_suppkey,
			:s_name,
			:s_address,
			:s_phone,
			:total_revenue
	do
		suspend;
end^
set term ;^

:staton
select * from query15;
:statoff

commit;
drop procedure query15;
drop view revenue0;
