-- @(#)18.sql	2.1.8.1
-- TPC-H/TPC-R Large Volume Customer Query (Q18)
-- Function Query Definition
-- Approved February 1998
set term ^;
create procedure query18
	returns (c_name varchar(25), c_custkey integer,
		o_orderkey integer, o_orderdate date,
		o_totalprice numeric(18,2), l_quantity_sum integer)
as
	declare variable l_orderkey integer;
begin
	for
		select
			l_orderkey
		from
			lineitem
		group by
			l_orderkey
		having
			sum(l_quantity) > 300
		into
			:l_orderkey
	do
	begin
		for
			select
				c_name,
				c_custkey,
				o_orderkey,
				o_orderdate,
				o_totalprice,
				sum(l_quantity)
			from
				customer,
				orders,
				lineitem
			where
				o_orderkey = :l_orderkey
				and c_custkey = o_custkey
				and o_orderkey = l_orderkey
			group by
				c_name,
				c_custkey,
				o_orderkey,
				o_orderdate,
				o_totalprice
			into
				:c_name,
				:c_custkey,
				:o_orderkey,
				:o_orderdate,
				:o_totalprice,
				:l_quantity_sum
		do
			suspend;
	end
end^
set term ;^

:staton
select first 100
	c_name,
	c_custkey,
	o_orderkey,
	o_orderdate,
	o_totalprice,
	l_quantity_sum
from
	query18
order by
	o_totalprice desc,
	o_orderdate;
:statoff

commit;
drop procedure query18;
