-- @(#)3.sql	2.1.8.1
-- TPC-H/TPC-R Shipping Priority Query (Q3)
-- Functional Query Definition
-- Approved February 1998
set term ^;
create procedure query3
    returns (
        l_orderkey integer,
        revenue numeric(18,2),
        o_orderdate date,
        o_shippriority char(15) )
as
    declare variable c_custkey integer;
begin
    for
        select
            c_custkey
        from
            customer
        where
            c_mktsegment = 'BUILDING'
        into
            :c_custkey
    do
    begin
        for
            select
                o_orderkey,
                o_orderdate,
                o_shippriority
            from
                orders
            where
                o_custkey = :c_custkey
                and o_orderdate < date '1995-03-15'
            into
                :l_orderkey,
                :o_orderdate,
                :o_shippriority
        do
        begin
            for
                select
                    sum(l_extendedprice * (1-l_discount))
                from
                    lineitem
                where
                    l_orderkey = :l_orderkey
                    and l_shipdate > date '1995-03-15'
                plan
                    (lineitem index (rdb$primary6))
                into
                    :revenue
            do
                suspend;
        end
    end
end^
set term ;^
commit;

:staton	
select first 10
	*
from
	query3
order by
	revenue desc,
	o_orderdate;
:statoff

commit;
drop procedure query3;
