-- @(#)7.sql	2.1.8.1
-- TPC-H/TPC-R Volume Shipping Query (Q7)
-- Functional Query Definition
-- Approved February 1998
create view shipping (supp_nation, cust_nation, l_year, volume)
as select
	n1.n_name as supp_nation,
	n2.n_name as cust_nation,
	extract(year from l_shipdate) as l_year,
	cast(l_extendedprice * (1 - l_discount) as numeric(18,2)) as volume
from
	supplier,
	lineitem,
	orders,
	customer,
	nation n1,
	nation n2
where
	s_suppkey = l_suppkey
	and o_orderkey = l_orderkey
	and c_custkey = o_custkey
	and s_nationkey = n1.n_nationkey
	and c_nationkey = n2.n_nationkey
	and (
		(n1.n_name = 'FRANCE' and n2.n_name = 'GERMANY')
		or (n1.n_name = 'GERMANY' and n2.n_name = 'FRANCE')
	)
	and l_shipdate between date '1995-01-01' and date '1996-12-31'
;

:staton
select
	supp_nation,
	cust_nation,
	l_year,
	sum(volume) as revenue
from
	shipping
group by
	supp_nation,
	cust_nation,
	l_year
order by
	supp_nation,
	cust_nation,
	l_year;
:statoff	
commit;

drop view shipping;

