-- @(#)8.sql	2.1.8.1
-- TPC-H/TPC-R National Market Share Query (Q8)
-- Functional Query Definition
-- Approved February 1998
set term ^;
create procedure query8 (nationwanted char(25))
	returns (o_year integer, volumenation numeric(18,2),
		volume numeric(18,2))
as
	declare variable nation char(25);
begin
	for
		select
			extract(year from o_orderdate) as o_year,
			l_extendedprice * (1 - l_discount) as volume,
			n2.n_name as nation
		from
			part,
			supplier,
			lineitem,
			orders,
			customer,
			nation n1,
			nation n2,
			region
		where
			p_partkey = l_partkey
			and s_suppkey = l_suppkey
			and l_orderkey = o_orderkey
			and o_custkey = c_custkey
			and c_nationkey = n1.n_nationkey
			and n1.n_regionkey = r_regionkey
			and r_name = 'AMERICA'
			and s_nationkey = n2.n_nationkey
			and o_orderdate between date '1995-01-01' and date '1996-12-31'
			and p_type = 'ECONOMY ANODIZED STEEL'
		into
			:o_year,
			:volume,
			:nation
	do
	begin
		if (nation = nationwanted) then
			volumenation = volume;
		else
			volumenation = 0;
		suspend;
	end
end^
set term ;^

:staton
select
	o_year,
	sum(volumenation) / sum(volume) as mkt_share
from
	query8('BRAZIL')
group by
	o_year
order by
	o_year;
:statoff	
commit;

drop procedure query8;

