-- @(#)9.sql	2.1.8.1
-- TPC-H/TPC-R Product Type Profit Measure Query (Q9)
-- Functional Query Definition
-- Approved February 1998
create view profit(nation, o_year, amount)
as select
	n_name as nation,
	extract(year from o_orderdate) as o_year,
	cast(l_extendedprice * (1 - l_discount) - ps_supplycost * l_quantity as numeric(18,2)) as amount
from
	part,
	supplier,
	lineitem,
	partsupp,
	orders,
	nation
where
	s_suppkey = l_suppkey
	and ps_suppkey = l_suppkey
	and ps_partkey = l_partkey
	and p_partkey = l_partkey
	and o_orderkey = l_orderkey
	and s_nationkey = n_nationkey
	and p_name like '%green%'
;

:staton
select
	nation,
	o_year,
	sum(amount) as sum_profit
from
	profit
group by
	nation,
	o_year
order by
	nation,
	o_year desc;
:statoff
commit;

drop view profit;

